#include <iostream>
#include "Vector.h"

using namespace std;

// Constructor
template <class ElementType>
Vector<ElementType>::Vector(int Size) {
   VSize = Size;
   v = new ElementType[VSize];
   for (int i=0; i < VSize ; ++ i) v[i] = 0;
}

// Copy constructor
template <class ElementType>
Vector<ElementType>::Vector(const Vector<ElementType> & r) {
   VSize = r.VSize;
   v = new ElementType[VSize];
   for (int i=0; i < VSize ; ++ i) v[i] = r.v[i];
}

// Destructor
template <class ElementType>
Vector<ElementType>::~Vector()
{
   delete [] v;
}

template <class ElementType>
Vector<ElementType> &
Vector<ElementType>::operator= (const Vector<ElementType> & r) {
   // Should make sure the vectors are of equal size, but
   // I am not! Oh well, ... this is just an example.

   for (int i=0 ; i < VSize ; ++ i) v[i] = r.v[i];
   return (*this);
}

template <class ElementType>
Vector<ElementType> 
Vector<ElementType>::operator+ (const Vector<ElementType> & r) const {
   // Should make sure the vectors are of equal size, but
   // I am not! Oh well, ... this is just an example.

   Vector<ElementType> temp(VSize);
   for (int i=0 ; i < VSize ; ++ i) temp.v[i] = v[i] + r.v[i];
   return (temp);
}

template <class ElementType>
Vector<ElementType> 
Vector<ElementType>::operator- (const Vector<ElementType> & r) const {
   // Should make sure the vectors are of equal size, but
   // I am not! Oh well, ... this is just an example.

   Vector<ElementType> temp(VSize);
   for (int i=0 ; i < VSize ; ++ i) temp.v[i] = v[i] - r.v[i];
   return (temp);
}

template <class ElementType>
ElementType 
Vector<ElementType>::operator^ (const Vector<ElementType> & r) const {
   // Should make sure the vectors are of equal size, but
   // I am not! Oh well, ... this is just an example.

   ElementType t = v[0]*r.v[0];
   for (int i=1 ; i < VSize ; ++ i) t += v[i]*r.v[i];
   return (t);
}

template <class ElementType>
ElementType & 
Vector<ElementType>::operator[] (int Index) {
   return v[Index];
}

template <class ElementType>
void Vector<ElementType>::PrintVector() const {
   cout << "[";
   for (int i=0 ; i < VSize-1 ; ++ i) cout << v[i] << " ";
   cout << v[VSize-1] << "]\n";
}

template class Vector<int>;
template class Vector<float>;

