template <class ElementType>
class Vector {
   private:
         // The size of the vector
         int VSize;

         // The vector itself
         ElementType *v; 

   public:

         // Constructor
         Vector(int Size);

         // Copy constructor
         Vector(const Vector & r);

         // Destructor
         ~Vector();

         // Vector assignment
         Vector<ElementType> & operator= (const Vector<ElementType> & r);

         // Vector addition
         Vector<ElementType> operator+ (const Vector<ElementType> & r) const;

         // Vector subtraction
         Vector<ElementType> operator- (const Vector<ElementType> & r) const;

         // Vector dot product
         ElementType operator^ (const Vector<ElementType> & r) const;

         // Element access
         ElementType & operator[](int Index);
 
         // Print the vector
         void PrintVector() const;
};

